/////////////////////////////////////////////////////////////////////////////
// Bdd.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>		// required for all Windows applications
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"

#include "../pluginaudio.h"


extern int Prefilter, Postfilter, Pitch, Amp, table;
extern QuenotteTV_AudioPlugin AudioPlugin;
void Priority(HWND hDlg);
BOOL Stop();


BOOL APIENTRY AboutProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
   
	switch (message)
	{
        case WM_INITDIALOG:
			break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) 
			{
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}


BOOL APIENTRY PluginAudioProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
char Text[255];
HWND hPitch = GetDlgItem( hDlg, IDC_PITCH );
BOOL apply=FALSE; 

	switch (message)
	{
        case WM_INITDIALOG:
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_PREFILTER));
            ComboBox_AddString(GetDlgItem(hDlg,IDC_PREFILTER), (LONG)(LPSTR)"Aucun");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_PREFILTER), (LONG)(LPSTR)"Wilma");
			if (AudioPlugin.Soundfreq==48000)
			{
				ComboBox_AddString(GetDlgItem(hDlg,IDC_PREFILTER), (LONG)(LPSTR)"Wilma+Bass");
			} else {
							if (Prefilter==2)
							{
								Prefilter=1;
							}
			}
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PREFILTER), Prefilter); 
            ComboBox_ResetContent(GetDlgItem(hDlg,IDC_POSTFILTER));
            ComboBox_AddString(GetDlgItem(hDlg,IDC_POSTFILTER), (LONG)(LPSTR)"Aucun");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_POSTFILTER), (LONG)(LPSTR)"Wilma");
			ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_POSTFILTER), Postfilter); 
			ComboBox_ResetContent(GetDlgItem(hDlg,IDC_FREQUENCE));
			ComboBox_AddString(GetDlgItem(hDlg,IDC_FREQUENCE), (LONG)(LPSTR)"25600");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_FREQUENCE), (LONG)(LPSTR)"28000");
            ComboBox_AddString(GetDlgItem(hDlg,IDC_FREQUENCE), (LONG)(LPSTR)"44100");
			ComboBox_AddString(GetDlgItem(hDlg,IDC_FREQUENCE), (LONG)(LPSTR)"48000");
			ComboBox_AddString(GetDlgItem(hDlg,IDC_FREQUENCE), (LONG)(LPSTR)"96000");

			switch (AudioPlugin.Soundfreq)
			{
			case 25600:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE), 0);
				break;
			case 28000:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE), 1);
				break;
			case 44100:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE), 2);
				break;
			case 48000:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE), 3);
				break;
			case 96000:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE), 4);
				break;
			}
			Priority(hDlg);
			
			switch (AudioPlugin.Priorityaudio)
			{
			case THREAD_PRIORITY_LOWEST:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PRIORITY), 0);
				break;
			case THREAD_PRIORITY_NORMAL:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PRIORITY), 1);
				break;
			case THREAD_PRIORITY_ABOVE_NORMAL:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PRIORITY), 2);
				break;
			case THREAD_PRIORITY_HIGHEST:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PRIORITY), 3);
				break;
			case THREAD_PRIORITY_TIME_CRITICAL:
				ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PRIORITY), 4);
				break;
			}
			SetDlgItemInt(hDlg, IDC_BUFFERS,AudioPlugin.Buffers,TRUE);
            SetDlgItemInt(hDlg, IDC_BUFFER_SIZE,AudioPlugin.Buflen/2,TRUE);  
			SetDlgItemInt(hDlg, IDC_EDIT3,Amp,TRUE);

			CheckDlgButton(hDlg, IDC_CHECK1, AudioPlugin.AutoProcessAudio);
			CheckDlgButton(hDlg, IDC_CHECK2, table);

            sprintf(Text,"%d",Pitch); 
			SetDlgItemText(hDlg,IDC_PITCHNUMBER,Text);
			SendMessage( hPitch, TBM_SETRANGEMAX, TRUE, 50 );
			SendMessage( hPitch, TBM_SETRANGEMIN, TRUE, -50 );
			SendMessage( hPitch, TBM_SETTICFREQ, 50, 0 );
			SendMessage( hPitch,   TBM_SETPOS, TRUE, Pitch );
			break;

		case WM_HSCROLL:
	        if((HWND)lParam == hPitch)
			{
				Pitch = SendMessage( hPitch,   TBM_GETPOS, 0, 0 );
				SetDlgItemInt(hDlg,IDC_PITCHNUMBER,Pitch,TRUE);
			}
			break;

		case WM_COMMAND:

			switch (LOWORD(wParam))
			{

				case IDC_BUTTON1:
					DialogBox(AudioPlugin.hDllInstance,"ABOUT",hDlg,(DLGPROC)AboutProc);
					break;

				case IDC_BUTTON2:
					if((Amp>0) && (Amp<16))	Amp++;
					SetDlgItemInt(hDlg, IDC_EDIT3,Amp,TRUE);
					break;

				case IDC_BUTTON3:
					if((Amp>1) && (Amp<17))	Amp--;
					SetDlgItemInt(hDlg, IDC_EDIT3,Amp,TRUE);
					break;

				case IDC_BUTTON4:
					SetDlgItemInt(hDlg, IDC_BUFFERS,5,TRUE);
					SetDlgItemInt(hDlg, IDC_BUFFER_SIZE,2498,TRUE);  
					break;

				case IDC_BUTTON5:
					SetDlgItemInt(hDlg, IDC_BUFFERS,6,TRUE);
					SetDlgItemInt(hDlg, IDC_BUFFER_SIZE,3528,TRUE);  
					break;

				case IDC_BUTTON6:
					SetDlgItemInt(hDlg, IDC_BUFFERS,12,TRUE);
					SetDlgItemInt(hDlg, IDC_BUFFER_SIZE,1764,TRUE);  
					break;

				case IDC_BUTTON7:
					SetDlgItemInt(hDlg, IDC_BUFFERS,24,TRUE);
					SetDlgItemInt(hDlg, IDC_BUFFER_SIZE,882,TRUE);  
					break;
			
				case IDC_APPLY:
					apply=TRUE;
				case IDOK:
					Prefilter=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_PREFILTER));
					Postfilter=ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_POSTFILTER));
					AudioPlugin.Buffers=GetDlgItemInt(hDlg, IDC_BUFFERS, NULL, TRUE);
					if (AudioPlugin.Buffers < 0 || AudioPlugin.Buffers > 1024)
						AudioPlugin.Buffers=5;
					AudioPlugin.Buflen=GetDlgItemInt(hDlg, IDC_BUFFER_SIZE, NULL, TRUE)*2;
					if(AudioPlugin.Buflen <0 || AudioPlugin.Buflen > 10000)
						AudioPlugin.Buflen=2498;
					Amp=GetDlgItemInt(hDlg, IDC_EDIT3,NULL,TRUE);
					AudioPlugin.AutoProcessAudio=IsDlgButtonChecked(hDlg, IDC_CHECK1);
					table=IsDlgButtonChecked(hDlg, IDC_CHECK2);


					switch (ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE)))
					{
						case 0:
							AudioPlugin.Soundfreq=25600;
							break;

						case 1:
							AudioPlugin.Soundfreq=28000;
							break;

						case 2:
							AudioPlugin.Soundfreq=44100;
							break;

						case 3:
							AudioPlugin.Soundfreq=48000;
							break;

						case 4:
							AudioPlugin.Soundfreq=96000;
							break;
					}

					switch (ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_PRIORITY)))
					{
						case 0:
							AudioPlugin.Priorityaudio=THREAD_PRIORITY_LOWEST;
							break;

						case 1:
							AudioPlugin.Priorityaudio=THREAD_PRIORITY_NORMAL;
							break;

						case 2:
							AudioPlugin.Priorityaudio=THREAD_PRIORITY_ABOVE_NORMAL;
							break;

						case 3:
							AudioPlugin.Priorityaudio=THREAD_PRIORITY_HIGHEST;
							break;

						case 4:
							AudioPlugin.Priorityaudio=THREAD_PRIORITY_TIME_CRITICAL;
							break;
					}

					Stop();
					SendMessage( AudioPlugin.hwndParent, WM_COMMAND, 40005, 0);
					Sleep( 10);
					SendMessage( AudioPlugin.hwndParent, WM_COMMAND, 40005, 0);
					if(apply) apply=FALSE;
					else
					{
						EndDialog(hDlg,TRUE);
					}
					break;

				case IDCANCEL:
					EndDialog(hDlg,0);
					break;
				case IDC_FREQUENCE:
					if ( HIWORD( wParam) == CBN_SELCHANGE) 
					{
						ComboBox_ResetContent(GetDlgItem(hDlg,IDC_PREFILTER));
						ComboBox_AddString(GetDlgItem(hDlg,IDC_PREFILTER), (LONG)(LPSTR)"Aucun");
						ComboBox_AddString(GetDlgItem(hDlg,IDC_PREFILTER), (LONG)(LPSTR)"Wilma");
						if (ComboBox_GetCurSel(GetDlgItem(hDlg,IDC_FREQUENCE))==3)
						{
							ComboBox_AddString(GetDlgItem(hDlg,IDC_PREFILTER), (LONG)(LPSTR)"Wilma+Bass");
						} else {
							if (Prefilter==2)
							{
								Prefilter=1;
							}
						}
						ComboBox_SetCurSel(GetDlgItem(hDlg,IDC_PREFILTER), Prefilter);
					}
				break;

			}
			break;
	}
	return(FALSE);
}