/////////////////////////////////////////////////////////////////////////////
// Divers.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include <commctrl.h>
#include <math.h>
#include <mmsystem.h> 
#include "../pluginaudio.h"



int Prefilter=1;		//prefiltre 1=ordre 5 2=ordre10
int Postfilter=1;		//postfiltre la ya que 1
int table=0;		
//int VolumeIn=52431;//strangers
//int VolumeOut=52431;//Strangers
int Pitch=0;//Grincheux
int Amp=1;//Grincheux
extern QuenotteTV_AudioPlugin AudioPlugin;
void Traitement28000 (PSHORT src , PSHORT dst);
void Traitement44100 (PSHORT src , PSHORT dst);
void Traitement48000 (PSHORT src , PSHORT dst);
void Traitement96000 (PSHORT src , PSHORT dst);
void Traitement25600 (PSHORT src , PSHORT dst);


void Traitement48000table (PSHORT src , PSHORT dst);
void Traitement44100table (PSHORT src , PSHORT dst);
void Traitement96000table (PSHORT src , PSHORT dst);
void Traitement25600table (PSHORT src , PSHORT dst);
void Traitement28000table (PSHORT src , PSHORT dst);
void InitialisationDecodertable();


#define M_PI    3.14159265358979323846264338327950288419716939937510582097494459


double decy0, decy1, deccte;

float postXV[7+1];
float postYV[7+1];

float preXV[4+1];
float preYV[4+1];

//////////////////
/*float pre1XV[7];
float pre1YV[7];

float post1XV[7];
float post1YV[7];*/
//////////////

void InitialisationDecoder()
{
    double w;
	
	w=2*M_PI*12800/(AudioPlugin.Soundfreq+Pitch);      
    deccte=2.0 * cos(w);
    decy0= cos(2*w);
    decy1= cos(w);
}

void InitialisationDec()
{
if (table)
	{InitialisationDecodertable();}
else
	{InitialisationDecoder();}
}


void InitialisationPreFiltre()
{
    int i;
	for( i=0; i<5; i++)
    {
        preXV[i]=0.0;
        preYV[i]=0.0;
    }
	//////////////////////
	/*for( i=0; i<7; i++)
    {
        pre1XV[i]=0.0;
        pre1YV[i]=0.0;
    }*/
	/////////////////
}


void InitialisationPostFiltre()
{
    int i;
	for( i=0; i<8; i++)
    {
        postXV[i]=0.0;
        postYV[i]=0.0;
    }
 /////////////////
	/*for( i=0; i<7; i++)
    {
        post1XV[i]=0.0;
        post1YV[i]=0.0;
    }*/
	///////////////
}


void Traitement (PSHORT src , PSHORT dst)
{
	if (AudioPlugin.Soundfreq==44100)  
	{
		if (table)
		{
			Traitement44100table ( src , dst);
		} else {
			Traitement44100 ( src , dst);
		}

	} else if (AudioPlugin.Soundfreq==48000) {
		if (table)
		{
			Traitement48000table ( src , dst);
		} else {
			Traitement48000 ( src , dst);
		}

	} else if (AudioPlugin.Soundfreq==28000) {
		if (table)
		{
			Traitement28000table ( src , dst);
		} else {
			Traitement28000 ( src , dst);
		}

	} else if (AudioPlugin.Soundfreq==96000) {
		if (table)
		{
			Traitement96000table ( src , dst);
		} else {
			Traitement96000 ( src , dst);
		}

	} else if (AudioPlugin.Soundfreq==25600) {
			if (table) 
			{
			Traitement25600table ( src , dst);
		} else {
			Traitement25600 ( src , dst);
		}
	}
}


void Traitement44100 (PSHORT src , PSHORT dst)
{
	int       i ;
	double	  decy;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
				
		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 6.310833714);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.0622354481 * preYV[0]) + ( -0.0826699057 * preYV[1])
					+ ( -0.7552376542 * preYV[2]) + ( -0.6351796968 * preYV[3]));//GDS
				*src=(short)preYV[4];
			}
			
			decy=(deccte * decy1) - decy0;  
			decy0=decy1;
			decy1=decy;
			
			*dst = (short)(*src * decy);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 2.211596484e+02);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.0935164959 * postYV[0]) + (  -0.4657366789 * postYV[1])
					+ ( 1.2531881677 * postYV[2]) + (  -2.2854956347 * postYV[3])
					+ ( 2.9413622606 * postYV[4]) + (  -2.9346526015 * postYV[5])
					+ ( 1.8190505669 * postYV[6]));
				*(dst)=(short)postYV[7];
			}
			*dst = *dst*Amp;
			src++;
			dst++;
		}
	}
}

	
void Traitement48000 (PSHORT src , PSHORT dst)
{
	int       i ;
	double	  decy;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		

		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 8.183340972);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.0626606278 * preYV[0]) + ( 0.0379954621 * preYV[1])
					+ ( -0.6759257285 * preYV[2]) + ( -0.2546007635 * preYV[3]));//GDS

				*src=(short)preYV[4];

/////////////////////////////////////////////
				/*pre1XV[0] = pre1XV[1]; pre1XV[1] = pre1XV[2]; pre1XV[2] = pre1XV[3]; pre1XV[3] = pre1XV[4];
				pre1XV[4] =(float)( *src / 1.021305981);//GDS
				pre1YV[0] = pre1YV[1]; pre1YV[1] = pre1YV[2]; pre1YV[2] = pre1YV[3]; pre1YV[3] = pre1YV[4];
				pre1YV[4] =(float)  ((pre1XV[0] + pre1XV[4]) - 3.5894127827 * (pre1XV[1] + pre1XV[3]) + 5.2209710311 * pre1XV[2]
					+ ( -0.9587686388 * pre1YV[0]) + ( 3.4775331326 * pre1YV[1])
					+ ( -5.1115620618 * pre1YV[2]) + ( 3.5515313201 * pre1YV[3]));//GDS

				*src=(short)pre1YV[4];*/


                /*pre1XV[0] = pre1XV[1]; pre1XV[1] = pre1XV[2]; pre1XV[2] = pre1XV[3]; pre1XV[3] = pre1XV[4];pre1XV[4] = pre1XV[5];pre1XV[5] = pre1XV[6];
				pre1XV[6] =(float)( *src / 1.04951396);//GDS
				pre1YV[0] = pre1YV[1]; pre1YV[1] = pre1YV[2]; pre1YV[2] = pre1YV[3]; pre1YV[3] = pre1YV[4];pre1YV[4] = pre1YV[5];pre1YV[5] = pre1YV[6];
				pre1YV[6] =(float)  ((pre1XV[0] + pre1XV[6]) - 5.3841191740 * (pre1XV[1] + pre1XV[5]) + 12.6629130930 * (pre1XV[2] +pre1XV[4])-  16.5489356440*pre1XV[3]
					+ ( -0.9077476036 * pre1YV[0]) + ( 4.9664855260 * pre1YV[1])
					+ ( -11.8698669430 * pre1YV[2]) + ( 5.7644146510 * pre1YV[3])
					+ ( -12.2590338720 * pre1YV[4]) + ( 5.2975042399 * pre1YV[5]));//GDS

				*src=(short)pre1YV[6];*/

				/*pre1XV[0] = pre1XV[1]; pre1XV[1] = pre1XV[2]; pre1XV[2] = pre1XV[3]; pre1XV[3] = pre1XV[4];pre1XV[4] = pre1XV[5];pre1XV[5] = pre1XV[6];
				pre1XV[6] =(float)( *src / 1.033267782);//GDS
				pre1YV[0] = pre1YV[1]; pre1YV[1] = pre1YV[2]; pre1YV[2] = pre1YV[3]; pre1YV[3] = pre1YV[4];pre1YV[4] = pre1YV[5];pre1YV[5] = pre1YV[6];
				pre1YV[6] =(float)  ((pre1XV[0] + pre1XV[6]) -   2.7417902756 * (pre1XV[1] + pre1XV[5]) + 5.5058046385 * (pre1XV[2] +pre1XV[4]) -   6.2469573057*pre1XV[3]
					+ ( -0.9366432851 * pre1YV[0]) + ( 2.5960916032 * pre1YV[1])
					+ ( -5.2698999724 * pre1YV[2]) + ( 6.0448786781 * pre1YV[3])
					+ ( -5.3861355264 * pre1YV[4]) + ( 2.7118833166 * pre1YV[5]));//GDS

				*src=(short)pre1YV[6];*/

				/*pre1XV[0] = pre1XV[1]; pre1XV[1] = pre1XV[2]; pre1XV[2] = pre1XV[3]; pre1XV[3] = pre1XV[4];pre1XV[4] = pre1XV[5];pre1XV[5] = pre1XV[6];
				pre1XV[6] =(float)( *src / 1.053761204);//GDS
				pre1YV[0] = pre1YV[1]; pre1YV[1] = pre1YV[2]; pre1YV[2] = pre1YV[3]; pre1YV[3] = pre1YV[4];pre1YV[4] = pre1YV[5];pre1YV[5] = pre1YV[6];
				pre1YV[6] =(float)  ((pre1XV[0] + pre1XV[6]) - 2.6546418207 * (pre1XV[1] + pre1XV[5]) + 5.3490410654 * (pre1XV[2] +pre1XV[4]) -   6.0021572693*pre1XV[3]
					+ ( -0.9005660890 * pre1YV[0]) + ( 2.4324008935 * pre1YV[1])
					+ ( -4.9862756338 * pre1YV[2]) + ( 5.6936336127 * pre1YV[3])
					+ ( -5.1634046561 * pre1YV[4]) + ( 2.6083148601 * pre1YV[5]));//GDS

				*src=(short)pre1YV[6];*/


/////////////////////////////////////////////////
/*				#define NZEROS 4
xv[0] = xv[1]; xv[1] = xv[2]; xv[2] = xv[3]; xv[3] = xv[4]; xv[4] = xv[5]; xv[5] = xv[6]; 
        xv[6] = next input value / GAIN;
        yv[0] = yv[1]; yv[1] = yv[2]; yv[2] = yv[3]; yv[3] = yv[4]; yv[4] = yv[5]; yv[5] = yv[6]; 
        yv[6] =   (xv[0] + xv[6]) -   2.6546418207 * (xv[1] + xv[5]) +   5.3490410654 * (xv[2] + xv[4])
                     -   6.0021572693 * xv[3]
                     + ( -0.9005660890 * yv[0]) + (  2.4324008935 * yv[1])
                     + ( -4.9862756338 * yv[2]) + (  5.6936336127 * yv[3])
                     + ( -5.1634046561 * yv[4]) + (  2.6083148601 * yv[5]);
        next output value = yv[6];

*/

////////////////////////////////////////////////////



			}
			else if (Prefilter==2)
			{
					preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 8.183340972);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[3]
					+ ( -0.0626606278 * preYV[0]) + ( 0.0379954621 * preYV[1])
					+ ( -0.6759257285 * preYV[2]) + ( -0.2546007635 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}


			decy=(deccte * decy1) - decy0;  
			decy0=decy1;
			decy1=decy;
			
			*dst = (short)(*src * decy);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 3.834721196e+02);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.1130488058 * postYV[0]) + (  -0.6208360469 * postYV[1])
					+ ( 1.7554209098 * postYV[2]) + (  -3.2416570827 * postYV[3])
					+ ( 4.1799016509 * postYV[4]) + (  -3.9042013855 * postYV[5])
					+ ( 2.3845309549 * postYV[6]));
				*(dst)=(short)postYV[7];


				////////////////////////////

/*post1XV[0] = post1XV[1]; post1XV[1] = post1XV[2]; post1XV[2] = post1XV[3]; post1XV[3] = post1XV[4]; post1XV[4] = post1XV[5]; post1XV[5] = post1XV[6];
				post1XV[6] = (float)((*dst) / 1.049513968);
				post1YV[0] = post1YV[1]; post1YV[1] = post1YV[2]; post1YV[2] = post1YV[3]; post1YV[3] = post1YV[4]; post1YV[4] = post1YV[5]; post1YV[5] = post1YV[6];
				post1YV[6] =  (float) ((post1XV[0] + post1XV[6])  -   2.1146324882 * (post1XV[1] + post1XV[5]) +4.4905568534 * (post1XV[2] + post1XV[4])
					-   4.5794849706 * (post1XV[3])
					+ ( -0.9077476036 * post1YV[0]) + (  1.9506053461 * post1YV[1])
					+ ( -4.2086763868 * post1YV[2]) + (  4.3619512588 * post1YV[3])
					+ ( -4.3466227578 * post1YV[4]) + (  2.0806141561 * post1YV[5]));
				*(dst)=(short)post1YV[6];*/






				//////////////////////////////
/*#define NZEROS 6
#define NPOLES 6
#define GAIN   1.049513968e+00

static float xv[NZEROS+1], yv[NPOLES+1];

static void filterloop()
  { for (;;)
      { xv[0] = xv[1]; xv[1] = xv[2]; xv[2] = xv[3]; xv[3] = xv[4]; xv[4] = xv[5]; xv[5] = xv[6]; 
        xv[6] = next input value / GAIN;
        yv[0] = yv[1]; yv[1] = yv[2]; yv[2] = yv[3]; yv[3] = yv[4]; yv[4] = yv[5]; yv[5] = yv[6]; 
        yv[6] =   (xv[0] + xv[6]) -   2.1146324882 * (xv[1] + xv[5]) +   4.4905568534 * (xv[2] + xv[4])
                     -   4.5794849706 * xv[3]
                     + ( -0.9077476036 * yv[0]) + (  1.9506053461 * yv[1])
                     + ( -4.2086763868 * yv[2]) + (  4.3619512588 * yv[3])
                     + ( -4.3466227578 * yv[4]) + (  2.0806141561 * yv[5]);
        next output value = yv[6];
      }
*/
				/////////////////////////////////
			}

			*dst = *dst*Amp;
			src++;
			dst++;
		}
	}
}

void Traitement28000 (PSHORT src , PSHORT dst)
{
	int       i ;
	double	  decy;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		
		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 1.497238168);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.4498778345 * preYV[0]) + ( -2.1450223211 * preYV[1])
					+ ( -3.8977979094 * preYV[2]) + ( -3.1936445246 * preYV[3]));//GDS
				*src=(short)preYV[4];
			}
			decy=(deccte * decy1) - decy0;  
			decy0=decy1;
			decy1=decy;
	
			*dst = (short)(*src * decy);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 1.058175797e+01);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.0158398918 * postYV[0]) + (  -0.0989743038 * postYV[1])
					+ ( -0.4806770487 * postYV[2]) + (  -1.5976153081 * postYV[3])
					+ ( -2.8744063538 * postYV[4]) + (  -3.5609112971 * postYV[5])
					+ ( -2.4995443421 * postYV[6]));
				*(dst)=(short)postYV[7];
			}
			*dst = *dst*Amp;
			src++;
			dst++;
		}
	}
}


void Traitement96000 (PSHORT src , PSHORT dst)
{
	int       i;
	double	  decy;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		

		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 7.486320862e+01);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.2082551105 * preYV[0]) + ( 0.9768363336 * preYV[1])
					+ ( -1.9591638847 * preYV[2]) + ( 1.9768595219 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}
			
			
			decy=(deccte * decy1) - decy0;  
			decy0=decy1;
			decy1=decy;
	
			*dst = (short)(*src * decy);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 3.508040262e+04);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.3339406563 * postYV[0]) + (  -2.4120965667 * postYV[1])
					+ ( 7.7656156821 * postYV[2]) + (  -14.4501981950 * postYV[3])
					+ ( 16.8069704710 * postYV[4]) + (  -12.2491585080 * postYV[5])
					+ ( 5.2012776995 * postYV[6]));
				*(dst)=(short)postYV[7];
			}

			*dst = *dst*Amp;
			src++;
			dst++;
		}
	}
}

void Traitement25600 (PSHORT src , PSHORT dst)
{
	int       i;
	double	  decy;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		

		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 1.091256182);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.8400367511 * preYV[0]) + ( -3.5058911151 * preYV[1])
					+ ( -5.4909777508 * preYV[2]) + ( -3.8250960906 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}			
			decy=(deccte * decy1) - decy0;  
			decy0=decy1;
			decy1=decy;
	
			*dst = (short)(*src * decy);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 5.561213831);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( -0.0149874278 * postYV[0]) + (  -0.3054088784 * postYV[1])
					+ ( -1.4843264402 * postYV[2]) + (  -3.9335563225 * postYV[3])
					+ ( -6.3075567034 * postYV[4]) + (  -6.3087937978 * postYV[5])
					+ ( -3.6619283073 * postYV[6]));
				*(dst)=(short)postYV[7];
			}

			*dst = *dst*Amp;
			src++;
			dst++;
		}
	}
}

///////////////////////////////////


double tablecos[441];
int k=0;

void InitialisationDecodertable()
{
    double w;
	int i;
	
	w=2*M_PI*12800/(AudioPlugin.Soundfreq+Pitch);
	k=0;

	for ( i = 0 ; i < 441 ; i ++ ) 
		{
			tablecos[i]=0;
		}
    
	if (AudioPlugin.Soundfreq==44100)
	{
		for ( i = 0 ; i < 441 ; i ++ ) // 12800/44100=128/441
		{
			tablecos[i]=cos(w*i);
		}
	}

	if (AudioPlugin.Soundfreq==48000) // 12800/48000=4/15
	{
		for ( i = 0 ; i < 15 ; i ++ )
		{
			tablecos[i]=cos(w*i);
		}
	}
	if (AudioPlugin.Soundfreq==96000) // 12800/96000=2/15
	{
		for ( i = 0 ; i < 15 ; i ++ )
		{
			tablecos[i]=cos(w*i);
		}
	}
	if (AudioPlugin.Soundfreq==25600) // 12800/25600=1/2
	{
		tablecos[0]=1;
		tablecos[1]=-1;
	}
	if (AudioPlugin.Soundfreq==28000) // 12800/28000=16/35
	{
		for ( i = 0 ; i < 35 ; i ++ )
		{
			tablecos[i]=cos(w*i);
		}
	}

}

void Traitement48000table (PSHORT src , PSHORT dst)
{
	int       i;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		

		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 8.183340972);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.0626606278 * preYV[0]) + ( 0.0379954621 * preYV[1])
					+ ( -0.6759257285 * preYV[2]) + ( -0.2546007635 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}
			else if (Prefilter==2)
			{
					preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 8.183340972);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[3]
					+ ( -0.0626606278 * preYV[0]) + ( 0.0379954621 * preYV[1])
					+ ( -0.6759257285 * preYV[2]) + ( -0.2546007635 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}
			
			*dst = (short)(*src*tablecos[k]);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 3.834721196e+02);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.1130488058 * postYV[0]) + (  -0.6208360469 * postYV[1])
					+ ( 1.7554209098 * postYV[2]) + (  -3.2416570827 * postYV[3])
					+ ( 4.1799016509 * postYV[4]) + (  -3.9042013855 * postYV[5])
					+ ( 2.3845309549 * postYV[6]));
				*(dst)=(short)postYV[7];
			}

			*dst = *dst*Amp;
			src++;
			dst++;
			//k=(k+1)%15;
			k++;
			if (k > 14)
			{
				k=0;
			}
		}
	}
}

void Traitement44100table (PSHORT src , PSHORT dst)
{
	int       i ;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
				
		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 6.310833714);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.0622354481 * preYV[0]) + ( -0.0826699057 * preYV[1])
					+ ( -0.7552376542 * preYV[2]) + ( -0.6351796968 * preYV[3]));//GDS
				*src=(short)preYV[4];
			}
			
			*dst = (short)(*src*tablecos[k]);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 2.211596484e+02);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.0935164959 * postYV[0]) + (  -0.4657366789 * postYV[1])
					+ ( 1.2531881677 * postYV[2]) + (  -2.2854956347 * postYV[3])
					+ ( 2.9413622606 * postYV[4]) + (  -2.9346526015 * postYV[5])
					+ ( 1.8190505669 * postYV[6]));
				*(dst)=(short)postYV[7];
			}
			*dst = *dst*Amp;
			src++;
			dst++;
			k++;
			if (k > 440)
			{
				k=0;
			}
		}
	}
}

void Traitement96000table (PSHORT src , PSHORT dst)
{
	int       i;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		

		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 7.486320862e+01);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.2082551105 * preYV[0]) + ( 0.9768363336 * preYV[1])
					+ ( -1.9591638847 * preYV[2]) + ( 1.9768595219 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}
			
			
			*dst = (short)(*src*tablecos[k]);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 3.508040262e+04);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.3339406563 * postYV[0]) + (  -2.4120965667 * postYV[1])
					+ ( 7.7656156821 * postYV[2]) + (  -14.4501981950 * postYV[3])
					+ ( 16.8069704710 * postYV[4]) + (  -12.2491585080 * postYV[5])
					+ ( 5.2012776995 * postYV[6]));
				*(dst)=(short)postYV[7];
			}

			*dst = *dst*Amp;
			src++;
			dst++;
			k++;
			if (k > 14)
			{
				k=0;
			}
		}
	}
}

void Traitement25600table (PSHORT src , PSHORT dst)
{
	int       i;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		

		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 1.091256182);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.8400367511 * preYV[0]) + ( -3.5058911151 * preYV[1])
					+ ( -5.4909777508 * preYV[2]) + ( -3.8250960906 * preYV[3]));//GDS

				*src=(short)preYV[4];
			}			
			*dst = (short)(*src * tablecos[k]);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 5.561213831);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( -0.0149874278 * postYV[0]) + (  -0.3054088784 * postYV[1])
					+ ( -1.4843264402 * postYV[2]) + (  -3.9335563225 * postYV[3])
					+ ( -6.3075567034 * postYV[4]) + (  -6.3087937978 * postYV[5])
					+ ( -3.6619283073 * postYV[6]));
				*(dst)=(short)postYV[7];
			}

			*dst = *dst*Amp;
			src++;
			dst++;
			k++;
			if (k > 1)
			{
				k=0;
			}
		}
	}
}

void Traitement28000table (PSHORT src , PSHORT dst)
{
	int       i ;
	double	  decy;
	
	{
		// Une seule boucle pour tout le traitement donc temps de decodage/3
		// et plus de parasites. S'il en subsite essayer prefiltre=2 ou diminuer les valeurs
		// du volume d enregistrement
		// La routine de decodage provient de cpluswin de toute facon y'a qu'une seule facon de faire
		// les filtre on ete generes grace a A.J. Fisher
		
		for ( i = 0 ; i < AudioPlugin.Buflen / 2 ; i ++ )
		{
			if (Prefilter==1)
			{
				preXV[0] = preXV[1]; preXV[1] = preXV[2]; preXV[2] = preXV[3]; preXV[3] = preXV[4];
				preXV[4] =(float)( *src / 1.497238168);//GDS
				preYV[0] = preYV[1]; preYV[1] = preYV[2]; preYV[2] = preYV[3]; preYV[3] = preYV[4];
				preYV[4] =(float)  ((preXV[0] + preXV[4]) + 4 * (preXV[1] + preXV[3]) + 6 * preXV[2]
					+ ( -0.4498778345 * preYV[0]) + ( -2.1450223211 * preYV[1])
					+ ( -3.8977979094 * preYV[2]) + ( -3.1936445246 * preYV[3]));//GDS
				*src=(short)preYV[4];
			}
			decy=(deccte * decy1) - decy0;  
			decy0=decy1;
			decy1=decy;
	
			*dst = (short)(*src * decy);
			
			if (Postfilter)
			{
				postXV[0] = postXV[1]; postXV[1] = postXV[2]; postXV[2] = postXV[3]; postXV[3] = postXV[4]; postXV[4] = postXV[5]; postXV[5] = postXV[6]; postXV[6] = postXV[7];
				postXV[7] = (float)((*dst) / 1.058175797e+01);
				postYV[0] = postYV[1]; postYV[1] = postYV[2]; postYV[2] = postYV[3]; postYV[3] = postYV[4]; postYV[4] = postYV[5]; postYV[5] = postYV[6]; postYV[6] = postYV[7];
				postYV[7] =  (float) ((postXV[0] + postXV[7]) + 7 * (postXV[1] + postXV[6]) + 21 * (postXV[2] + postXV[5])
					+ 35 * (postXV[3] + postXV[4])
					+ ( 0.0158398918 * postYV[0]) + (  -0.0989743038 * postYV[1])
					+ ( -0.4806770487 * postYV[2]) + (  -1.5976153081 * postYV[3])
					+ ( -2.8744063538 * postYV[4]) + (  -3.5609112971 * postYV[5])
					+ ( -2.4995443421 * postYV[6]));
				*(dst)=(short)postYV[7];
			}
			*dst = *dst*Amp;
			src++;
			dst++;
			k++;
			if (k > 34)
			{
				k=0;
			}
		}
	}
}